QGIS Application - Bug report #9429
slow selection of features
2014-01-26 04:42 PM - Alvaro Huarte

Status: Closed

Priority: High

Assignee: Alvaro Huarte

Category: Vectors

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 18023
Description

Any selection of features in QGIS calls to 'QgsVectorLayer::setSelectedFeatures' and from this commit
(#39fab67e602aaa8be7e561a50b40ab7c38914258) it loads all featurelds even when none features were selected.

When the layer has many features, it is a big bottleneck!

| think that this verification is unneccesary in most of situations because of selections become from a 'QgsFeaturelterator fit =
getFeatures(...)' calls.

| will propose that this verification be optional (disabled by default) and also it will ignore the unnecesary 'allFeaturelds()' call when none
feature was selected.

History

#1 - 2014-01-26 04:43 PM - Alvaro Huarte
- Affected QGIS version changed from 2.0.1 to master

#2 - 2014-01-26 05:16 PM - Nathan Woodrow

| agree the check is not needed. We have the ids and if they are not in the layer then they just don't get selected no need to check before hand.

Remove it.

#3 - 2014-01-26 05:35 PM - Alvaro Huarte

Nathan Woodrow wrote:

| agree the check is not needed. We have the ids and if they are not in the layer then they just don't get selected no need to check before hand.

Remove it.

Done:
https://github.com/qgis/QGIS/pull/1114

#4 - 2014-01-26 05:35 PM - Alvaro Huarte
- Resolution set to fixed/implemented
- Pull Request or Patch supplied changed from No to Yes
https://github.com/qgis/QGIS/pull/1114

#5 - 2014-01-26 05:45 PM - Alvaro Huarte
- Status changed from Open to Closed

#6 - 2014-01-26 11:58 PM - Alvaro Huarte

- Status changed from Closed to Reopened

Reopened to enable ids validation in new optional parameter:

QgsVectorLayer::setSelectedFeatures( const QgsFeaturelds& ids, bool valdiatelds = false )

See:
https://github.com/qgis/QGIS/pull/1114#issuecomment-33346858

#7 - 2014-01-27 12:50 AM - Giovanni Manghi

- Category changed from Browser to Vectors

Hi Alvaro, thanks for looking into this long standing and painful issue.

Does this

#9348

duplicates this ticket?

cheers!

#8 - 2014-01-28 11:49 PM - Alvaro Huarte

- Status changed from Reopened to Resolved

#9 - 2014-01-28 11:49 PM - Alvaro Huarte

- Status changed from Resolved to Closed

#10 - 2014-01-29 08:30 AM - Rhenriques Henriques

- Status changed from Closed to Reopened

Be careful because this problem is not solved. Selection remains slow as before in the latest NB. Even with the modifications suggested by Alvaro from

here "https://github.com/qgis/QGIS/pull/1116/files", the problem remains the same with huge databases.

These videos show the problem

http://www.dct.uminho.pt/smallsetselection.mp4

http://www.dct.uminho.pt/largesetselection.mp4

I'll wait for the next few days NB's to make further comments on developments.
I hope this gets fixed.

Cheers
https://github.com/qgis/QGIS/pull/1114#issuecomment-33346858
http://www.dct.uminho.pt/smallsetselection.mp4
http://www.dct.uminho.pt/largesetselection.mp4

#11 - 2014-01-29 08:36 AM - Alvaro Huarte

Rhenriques Henriques wrote:

Be careful because this problem is not solved. Selection remains slow as before in the latest NB. Even with the modifications suggested by Alvaro
from here "https.//github.com/qgis/QGIS/pull/1116/files”, the problem remains the same with huge databases.

These videos show the problem

http.//www.dct.uminho.pt/smallsetselection.mp4

htto.//www.dct.uminho.pt/largesetselection.mp4

I'll wait for the next few days NB's to make further comments on developments.

| hope this gets fixed.

Cheers

But this issue is about other use case.
I have not closed the issue #9348

#12 - 2014-01-29 02:37 PM - Giovanni Manghi

But this issue is about other use case.

| have not closed the issue #9348

the patch proposed has been merged and anyway it seems duplicate of #9348, or not? closing?

#13 - 2014-01-29 02:44 PM - Alvaro Huarte

| think so

#14 - 2014-01-29 02:51 PM - Giovanni Manghi
- Status changed from Reopened to Closed
